#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>

#define		MAXPATHLEN	128

int pathopen(name,mode,mask)
  const char *name;	/* search PATH for file name, return file descriptor */
  int mode,mask;	/* additional parms for open */
{
  register char *np, *path;
  int fd;
  char filename[MAXPATHLEN+1];
  if ( *name == '/' || !(path = getenv("PATH"))) path = "";
  for (;;) {
	if (!(np = strchr(path, ':')))
		np = path + strlen(path);	/* point to end str */
	if (np - path <= 1)			/* %% */
		(void) strcpy(filename, name);
	else {
		(void) strncpy(filename, path, np - path);
		filename[np - path] = '/';
		(void) strcpy(filename + (np - path) + 1, name);
	}
	fd = open(filename,mode,mask);
	if (fd >= 0) return fd;
	if (!*np) return -1;	/* can't find name */
	path = np + 1;
  }
}
